/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	HACPBusinessAction
//	変更履歴
//		2004.02.01	新規作成
//

package jp.co.ntt.lms.lo.scorm.engine;

import java.net.URLEncoder;
import java.util.Iterator;

import javax.servlet.ServletContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import jp.co.ntt.lms.lo.scorm.util.Debug;
import jp.co.ntt.lms.lo.scorm.util.SG;
import jp.co.ntt.lms.xms.framework.XmsBusinessAction;
import jp.co.ntt.lms.xms.framework.XmsException;
import jp.co.ntt.lms.xms.framework.XmsRequest;
import jp.co.ntt.lms.xms.framework.XmsResponse;

/**
 *	HACPBusinessAction クラス<br>
 *	SCOからのHACP要求を受け付けるクラス<br>
 */
public class HACPBusinessAction extends XmsBusinessAction {
	/**
	 * デフォルトコンストラクタ
	 */
	public HACPBusinessAction() {}

	/**
	 * 初期化処理
	 *
	 * @param	xmsRequest	リクエストオブジェクト
	 */
	protected void initProcessRequest(XmsRequest xmsRequest) throws XmsException {}

	/**
	 * HACP要求受付処理
	 *
	 * @param	xmsRequest	リクエストオブジェクト
	 * @param	xmsResponse	レスポンスオブジェクト
	 */
	protected void processRequest(XmsRequest xmsRequest, XmsResponse xmsResponse) throws XmsException {
		String result;

		try {
			HttpServletRequest request = xmsRequest.getRequest();
			HttpSession session = request.getSession();
			ServletContext application = session.getServletContext();

			// sessionからapi adapterを取得する
			SCORMAPIAdapter adapter = (SCORMAPIAdapter)session.getAttribute("SCORM.API_ADAPTER");

			// sessionから取得できなかった場合 → Session Timeout 発生時
			if (adapter == null) {
				result =
					"error=5\nerror_text=Session Timeout\ndetail_error=1001\nversion="
						+ getVersionString(xmsRequest)
						+ "\naicc_data=";
			}
			// 正常にsessionから api adapter が取得できた場合
			else {
				StringBuffer param = new StringBuffer();

				Iterator iterator = xmsRequest.getParmaterNames().iterator();

				while (iterator.hasNext()) {
					String key = (String)iterator.next();
					String value = xmsRequest.getParameter(key);

					if (key.equalsIgnoreCase("command")) {
						if (param.length() > 0) {
							param.append("&");
						}
						param.append("command=");
						param.append(value);
					}
					else if (key.equalsIgnoreCase("version")) {
						if (param.length() > 0) {
							param.append("&");
						}
						param.append("version=");
						param.append(value);
					}
					else if (key.equalsIgnoreCase("session_id")) {
						if (param.length() > 0) {
							param.append("&");
						}
						param.append("session_id=");
						param.append(value);
					}
					else if (key.equalsIgnoreCase("AU_Password")) {
						if (param.length() > 0) {
							param.append("&");
						}
						param.append("AU_Password=");
						param.append(value);
					}
					else if (key.equalsIgnoreCase("AICC_Data")) {
						if (param.length() > 0) {
							param.append("&");
						}
						param.append("AICC_Data=");
						param.append(URLEncoder.encode(value, SG.get("HACPEncoding")));
					}
				}

				result = adapter.hacp(param.toString());
			}
		}
		catch (Exception ex) {
			Debug.write(ex);

			result =
				"error=4\nerror_text=CMI Error\ndetail_error=101\nversion="
					+ getVersionString(xmsRequest)
					+ "\naicc_data=";
		}

		HACPBusinessBean HACPBusinessBean = new HACPBusinessBean();

		HACPBusinessBean.setResult(result);

		xmsResponse.setBusinessBean(HACPBusinessBean);
	}

	/**
	 * XmsRequestパラメータを検索し、version文字列を取得する
	 *
	 * @param xmsRequest	リクエストオブジェクト
	 * @return 取得できたversion文字列を返却する。存在しなかった場合はnullを返却する
	 */
	private String getVersionString(XmsRequest xmsRequest) throws XmsException {
		String version = "";

		Iterator iterator = xmsRequest.getParmaterNames().iterator();

		while (iterator.hasNext()) {
			String key = (String)iterator.next();

			if (key.equalsIgnoreCase("version")) {
				version = xmsRequest.getParameter(key);
				break;
			}
		}

		return version;
	}
}
